---
product: "AG Grid"
title: "Row Animation"
description: "Row animations occur after filtering, sorting, resizing height and expanding / collapsing a row group and are enabled by default."
framework: javascript
version: "36.2.0"
related:
    - title: "Change Detection"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/change-detection/"
    - title: "DOM Virtualisation"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/dom-virtualisation/"
    - title: "Value Cache"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-cache/"
    - title: "Massive Row Count"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/massive-row-count/"
    - title: "Scrolling Performance"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/scrolling-performance/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Animation

Row animations occur after filtering, sorting, resizing height and expanding / collapsing a row group and are enabled by default.

## Disable Animation

Depending on how the grid is used, Row Animations can be a performance bottleneck. Row animations can be disabled by setting the grid option `animateRows = false`.

## Row Animations

The grid will animate the rows in the following scenarios:

- Column Animations:
  - Moving Columns
- Row Animations
  - Filtering Rows
  - Sorting Rows
  - Expanding / Collapsing Row Groups

The example below automatically triggers grid actions to demonstrate the animations.

#### Animation

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { ColumnMenuModule, SetFilterModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  SetFilterModule,
]);

let countDownDirection = true;

const columnDefs: ColDef[] = [
  { field: "athlete", minWidth: 150 },
  { field: "country", minWidth: 150 },
  { field: "year", minWidth: 120 },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    flex: 1,
    filter: true,
  },
  columnDefs: columnDefs,
};

// the code below executes an action every 2,000 milliseconds.
// it's an interval, and each time it runs, it takes the next action
// from the 'actions' list below
function startInterval(api: GridApi) {
  let actionIndex = 0;

  resetCountdown();
  executeAfterXSeconds();

  function executeAfterXSeconds() {
    setTimeout(() => {
      const action = getActions()[actionIndex];
      action(api);
      actionIndex++;
      if (actionIndex >= getActions().length) {
        actionIndex = 0;
      }
      resetCountdown();
      executeAfterXSeconds();
    }, 3000);
  }

  setTitleFormatted(null);
}

function resetCountdown() {
  (document.querySelector("#animationCountdown") as any).style.width =
    countDownDirection ? "100%" : "0%";
  countDownDirection = !countDownDirection;
}

function setTitleFormatted(
  apiName: null | string,
  methodName?: string,
  paramsName?: string,
) {
  let html;
  if (apiName === null) {
    html = '<span class="code-highlight-yellow">command:> </span>';
  } else {
    html =
      '<span class="code-highlight-yellow">command:> </span> ' +
      '<span class="code-highlight-blue">' +
      apiName +
      "</span>" +
      '<span class="code-highlight-blue">.</span>' +
      '<span class="code-highlight-yellow">' +
      methodName +
      "</span>" +
      '<span class="code-highlight-blue"></span>' +
      '<span class="code-highlight-blue">(</span>' +
      '<span class="code-highlight-green">' +
      paramsName +
      "</span>" +
      '<span class="code-highlight-blue">)</span>';
  }
  document.querySelector("#animationAction")!.innerHTML = html;
}

function getActions() {
  return [
    function (api: GridApi) {
      api.applyColumnState({
        state: [{ colId: "country", sort: "asc" }],
        defaultState: { sort: null },
      });
      setTitleFormatted("api", "applyColumnState", "country: 'asc'");
    },
    function (api: GridApi) {
      api.applyColumnState({
        state: [
          { colId: "year", sort: "asc" },
          { colId: "country", sort: "asc" },
        ],
        defaultState: { sort: null },
      });
      setTitleFormatted(
        "api",
        "applyColumnState",
        "year: 'asc', country 'asc'",
      );
    },
    function (api: GridApi) {
      api.applyColumnState({
        state: [
          { colId: "year", sort: "asc" },
          { colId: "country", sort: "desc" },
        ],
        defaultState: { sort: null },
      });
      setTitleFormatted(
        "api",
        "applyColumnState",
        "year: 'asc', country: 'desc'",
      );
    },
    function (api: GridApi) {
      api.applyColumnState({
        defaultState: { sort: null },
      });
      setTitleFormatted("api", "applyColumnState", "clear sort");
    },
  ];
}

// from actual demo page (/animation/)
const gridDiv =
  document.querySelector<HTMLElement>("#myGrid")! ||
  document.querySelector("#animationGrid");

gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then(function (data) {
    gridApi!.setGridOption("rowData", data.slice(0, 50));
    startInterval(gridApi!);
  });
```

[Live example: Animation](https://www.ag-grid.com/archive/36.2.0/examples/row-animation/animation/typescript/)

## Animation Sequence Details

You do not need to know how the animations work, however, if you are creating a theme or otherwise want to adjust the animations, it will be useful for you to understand the sequence of rules which are as follows:

- **New Rows:** Rows that are new to the grid are placed in the new position and faded in.
- **Old Rows:** Rows that are no longer in the grid are left in the same position and faded out.
- **Moved Rows:** Rows that are in a new position get their position transitioned to the new position.
- **Resized Height Rows:** Rows that get their height change will have the height transitioned to the new height.

In addition to the transition animations, old rows are placed behind new rows such that moving rows are on top of old rows when moved (hence old rows are not fading out on top of new rows, but behind new rows).


---
product: "AG Grid"
title: "Row Animation"
description: "Row animations occur after filtering, sorting, resizing height and expanding / collapsing a row group and are enabled by default."
framework: vue
version: "36.2.0"
related:
    - title: "Change Detection"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/change-detection/"
    - title: "DOM Virtualisation"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/dom-virtualisation/"
    - title: "Value Cache"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-cache/"
    - title: "Massive Row Count"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/massive-row-count/"
    - title: "Scrolling Performance"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/scrolling-performance/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Animation

Row animations occur after filtering, sorting, resizing height and expanding / collapsing a row group and are enabled by default.

## Disable Animation

Depending on how the grid is used, Row Animations can be a performance bottleneck. Row animations can be disabled by setting the grid option `animateRows = false`.

## Row Animations

The grid will animate the rows in the following scenarios:

- Column Animations:
  - Moving Columns
- Row Animations
  - Filtering Rows
  - Sorting Rows
  - Expanding / Collapsing Row Groups

The example below automatically triggers grid actions to demonstrate the animations.

#### Animation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { ColumnMenuModule, SetFilterModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  SetFilterModule,
]);

let countDownDirection = true;

// the code below executes an action every 2,000 milliseconds.
// it's an interval, and each time it runs, it takes the next action
// from the 'actions' list below
function startInterval(api: GridApi) {
  let actionIndex = 0;
  resetCountdown();
  executeAfterXSeconds();
  function executeAfterXSeconds() {
    setTimeout(() => {
      const action = getActions()[actionIndex];
      action(api);
      actionIndex++;
      if (actionIndex >= getActions().length) {
        actionIndex = 0;
      }
      resetCountdown();
      executeAfterXSeconds();
    }, 3000);
  }
  setTitleFormatted(null);
}

function resetCountdown() {
  (document.querySelector("#animationCountdown") as any).style.width =
    countDownDirection ? "100%" : "0%";
  countDownDirection = !countDownDirection;
}

function setTitleFormatted(
  apiName: null | string,
  methodName?: string,
  paramsName?: string,
) {
  let html;
  if (apiName === null) {
    html = '<span class="code-highlight-yellow">command:> </span>';
  } else {
    html =
      '<span class="code-highlight-yellow">command:> </span> ' +
      '<span class="code-highlight-blue">' +
      apiName +
      "</span>" +
      '<span class="code-highlight-blue">.</span>' +
      '<span class="code-highlight-yellow">' +
      methodName +
      "</span>" +
      '<span class="code-highlight-blue"></span>' +
      '<span class="code-highlight-blue">(</span>' +
      '<span class="code-highlight-green">' +
      paramsName +
      "</span>" +
      '<span class="code-highlight-blue">)</span>';
  }
  document.querySelector("#animationAction")!.innerHTML = html;
}

function getActions() {
  return [
    function (api: GridApi) {
      api.applyColumnState({
        state: [{ colId: "country", sort: "asc" }],
        defaultState: { sort: null },
      });
      setTitleFormatted("api", "applyColumnState", "country: 'asc'");
    },
    function (api: GridApi) {
      api.applyColumnState({
        state: [
          { colId: "year", sort: "asc" },
          { colId: "country", sort: "asc" },
        ],
        defaultState: { sort: null },
      });
      setTitleFormatted(
        "api",
        "applyColumnState",
        "year: 'asc', country 'asc'",
      );
    },
    function (api: GridApi) {
      api.applyColumnState({
        state: [
          { colId: "year", sort: "asc" },
          { colId: "country", sort: "desc" },
        ],
        defaultState: { sort: null },
      });
      setTitleFormatted(
        "api",
        "applyColumnState",
        "year: 'asc', country: 'desc'",
      );
    },
    function (api: GridApi) {
      api.applyColumnState({
        defaultState: { sort: null },
      });
      setTitleFormatted("api", "applyColumnState", "clear sort");
    },
  ];
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <div class="example-header-row">
          <div id="animationCountdown" class="transition-width" style="background-color: grey; height: 100%; width: 0%"></div>
        </div>
        <span id="animationAction"></span>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 150 },
      { field: "country", minWidth: 150 },
      { field: "year", minWidth: 120 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      filter: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data.slice(0, 50);
        startInterval(params.api!);
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Animation](https://www.ag-grid.com/archive/36.2.0/examples/row-animation/animation/vue3/)

## Animation Sequence Details

You do not need to know how the animations work, however, if you are creating a theme or otherwise want to adjust the animations, it will be useful for you to understand the sequence of rules which are as follows:

- **New Rows:** Rows that are new to the grid are placed in the new position and faded in.
- **Old Rows:** Rows that are no longer in the grid are left in the same position and faded out.
- **Moved Rows:** Rows that are in a new position get their position transitioned to the new position.
- **Resized Height Rows:** Rows that get their height change will have the height transitioned to the new height.

In addition to the transition animations, old rows are placed behind new rows such that moving rows are on top of old rows when moved (hence old rows are not fading out on top of new rows, but behind new rows).


---
product: "AG Grid"
title: "Row Animation"
description: "Row animations occur after filtering, sorting, resizing height and expanding / collapsing a row group and are enabled by default."
framework: angular
version: "36.2.0"
related:
    - title: "Change Detection"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/change-detection/"
    - title: "DOM Virtualisation"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/dom-virtualisation/"
    - title: "Value Cache"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-cache/"
    - title: "Massive Row Count"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/massive-row-count/"
    - title: "Scrolling Performance"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/scrolling-performance/"
    - title: "NgZone"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/angular-ngzone/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Animation

Row animations occur after filtering, sorting, resizing height and expanding / collapsing a row group and are enabled by default.

## Disable Animation

Depending on how the grid is used, Row Animations can be a performance bottleneck. Row animations can be disabled by setting the grid option `animateRows = false`.

## Row Animations

The grid will animate the rows in the following scenarios:

- Column Animations:
  - Moving Columns
- Row Animations
  - Filtering Rows
  - Sorting Rows
  - Expanding / Collapsing Row Groups

The example below automatically triggers grid actions to demonstrate the animations.

#### Animation

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { ColumnMenuModule, SetFilterModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  SetFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <div class="example-header-row">
        <div
          id="animationCountdown"
          class="transition-width"
          style="background-color: grey; height: 100%; width: 0%"
        ></div>
      </div>
      <span id="animationAction"></span>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 150 },
    { field: "country", minWidth: 150 },
    { field: "year", minWidth: 120 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    filter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data.slice(0, 50);
        startInterval(params.api!);
      });
  }
}

let countDownDirection = true;
// the code below executes an action every 2,000 milliseconds.
// it's an interval, and each time it runs, it takes the next action
// from the 'actions' list below
function startInterval(api: GridApi) {
  let actionIndex = 0;
  resetCountdown();
  executeAfterXSeconds();
  function executeAfterXSeconds() {
    setTimeout(() => {
      const action = getActions()[actionIndex];
      action(api);
      actionIndex++;
      if (actionIndex >= getActions().length) {
        actionIndex = 0;
      }
      resetCountdown();
      executeAfterXSeconds();
    }, 3000);
  }
  setTitleFormatted(null);
}
function resetCountdown() {
  (document.querySelector("#animationCountdown") as any).style.width =
    countDownDirection ? "100%" : "0%";
  countDownDirection = !countDownDirection;
}
function setTitleFormatted(
  apiName: null | string,
  methodName?: string,
  paramsName?: string,
) {
  let html;
  if (apiName === null) {
    html = '<span class="code-highlight-yellow">command:> </span>';
  } else {
    html =
      '<span class="code-highlight-yellow">command:> </span> ' +
      '<span class="code-highlight-blue">' +
      apiName +
      "</span>" +
      '<span class="code-highlight-blue">.</span>' +
      '<span class="code-highlight-yellow">' +
      methodName +
      "</span>" +
      '<span class="code-highlight-blue"></span>' +
      '<span class="code-highlight-blue">(</span>' +
      '<span class="code-highlight-green">' +
      paramsName +
      "</span>" +
      '<span class="code-highlight-blue">)</span>';
  }
  document.querySelector("#animationAction")!.innerHTML = html;
}
function getActions() {
  return [
    function (api: GridApi) {
      api.applyColumnState({
        state: [{ colId: "country", sort: "asc" }],
        defaultState: { sort: null },
      });
      setTitleFormatted("api", "applyColumnState", "country: 'asc'");
    },
    function (api: GridApi) {
      api.applyColumnState({
        state: [
          { colId: "year", sort: "asc" },
          { colId: "country", sort: "asc" },
        ],
        defaultState: { sort: null },
      });
      setTitleFormatted(
        "api",
        "applyColumnState",
        "year: 'asc', country 'asc'",
      );
    },
    function (api: GridApi) {
      api.applyColumnState({
        state: [
          { colId: "year", sort: "asc" },
          { colId: "country", sort: "desc" },
        ],
        defaultState: { sort: null },
      });
      setTitleFormatted(
        "api",
        "applyColumnState",
        "year: 'asc', country: 'desc'",
      );
    },
    function (api: GridApi) {
      api.applyColumnState({
        defaultState: { sort: null },
      });
      setTitleFormatted("api", "applyColumnState", "clear sort");
    },
  ];
}
```

[Live example: Animation](https://www.ag-grid.com/archive/36.2.0/examples/row-animation/animation/angular/)

## Animation Sequence Details

You do not need to know how the animations work, however, if you are creating a theme or otherwise want to adjust the animations, it will be useful for you to understand the sequence of rules which are as follows:

- **New Rows:** Rows that are new to the grid are placed in the new position and faded in.
- **Old Rows:** Rows that are no longer in the grid are left in the same position and faded out.
- **Moved Rows:** Rows that are in a new position get their position transitioned to the new position.
- **Resized Height Rows:** Rows that get their height change will have the height transitioned to the new height.

In addition to the transition animations, old rows are placed behind new rows such that moving rows are on top of old rows when moved (hence old rows are not fading out on top of new rows, but behind new rows).


---
product: "AG Grid"
title: "Row Animation"
description: "Row animations occur after filtering, sorting, resizing height and expanding / collapsing a row group and are enabled by default."
framework: react
version: "36.2.0"
related:
    - title: "Change Detection"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/change-detection/"
    - title: "DOM Virtualisation"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/dom-virtualisation/"
    - title: "Value Cache"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-cache/"
    - title: "Massive Row Count"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/massive-row-count/"
    - title: "Scrolling Performance"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/scrolling-performance/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Row Animation

Row animations occur after filtering, sorting, resizing height and expanding / collapsing a row group and are enabled by default.

## Disable Animation

Depending on how the grid is used, Row Animations can be a performance bottleneck. Row animations can be disabled by setting the grid option `animateRows = false`.

## Row Animations

The grid will animate the rows in the following scenarios:

- Column Animations:
  - Moving Columns
- Row Animations
  - Filtering Rows
  - Sorting Rows
  - Expanding / Collapsing Row Groups

The example below automatically triggers grid actions to demonstrate the animations.

#### Animation

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { ColumnMenuModule, SetFilterModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ColumnApiModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  SetFilterModule,
];

let countDownDirection = true;

// the code below executes an action every 2,000 milliseconds.
// it's an interval, and each time it runs, it takes the next action
// from the 'actions' list below
function startInterval(api: GridApi) {
  let actionIndex = 0;
  resetCountdown();
  executeAfterXSeconds();
  function executeAfterXSeconds() {
    setTimeout(() => {
      const action = getActions()[actionIndex];
      action(api);
      actionIndex++;
      if (actionIndex >= getActions().length) {
        actionIndex = 0;
      }
      resetCountdown();
      executeAfterXSeconds();
    }, 3000);
  }
  setTitleFormatted(null);
}

function resetCountdown() {
  (document.querySelector("#animationCountdown") as any).style.width =
    countDownDirection ? "100%" : "0%";
  countDownDirection = !countDownDirection;
}

function setTitleFormatted(
  apiName: null | string,
  methodName?: string,
  paramsName?: string,
) {
  let html;
  if (apiName === null) {
    html = '<span class="code-highlight-yellow">command:> </span>';
  } else {
    html =
      '<span class="code-highlight-yellow">command:> </span> ' +
      '<span class="code-highlight-blue">' +
      apiName +
      "</span>" +
      '<span class="code-highlight-blue">.</span>' +
      '<span class="code-highlight-yellow">' +
      methodName +
      "</span>" +
      '<span class="code-highlight-blue"></span>' +
      '<span class="code-highlight-blue">(</span>' +
      '<span class="code-highlight-green">' +
      paramsName +
      "</span>" +
      '<span class="code-highlight-blue">)</span>';
  }
  document.querySelector("#animationAction")!.innerHTML = html;
}

function getActions() {
  return [
    function (api: GridApi) {
      api.applyColumnState({
        state: [{ colId: "country", sort: "asc" }],
        defaultState: { sort: null },
      });
      setTitleFormatted("api", "applyColumnState", "country: 'asc'");
    },
    function (api: GridApi) {
      api.applyColumnState({
        state: [
          { colId: "year", sort: "asc" },
          { colId: "country", sort: "asc" },
        ],
        defaultState: { sort: null },
      });
      setTitleFormatted(
        "api",
        "applyColumnState",
        "year: 'asc', country 'asc'",
      );
    },
    function (api: GridApi) {
      api.applyColumnState({
        state: [
          { colId: "year", sort: "asc" },
          { colId: "country", sort: "desc" },
        ],
        defaultState: { sort: null },
      });
      setTitleFormatted(
        "api",
        "applyColumnState",
        "year: 'asc', country: 'desc'",
      );
    },
    function (api: GridApi) {
      api.applyColumnState({
        defaultState: { sort: null },
      });
      setTitleFormatted("api", "applyColumnState", "clear sort");
    },
  ];
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IOlympicData[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 150 },
    { field: "country", minWidth: 150 },
    { field: "year", minWidth: 120 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      filter: true,
    };
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: IOlympicData[]) => {
        setRowData(data.slice(0, 50));
        startInterval(params.api!);
      });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <div className="example-header-row">
              <div
                id="animationCountdown"
                className="transition-width"
                style={{ backgroundColor: "grey", height: "100%", width: "0%" }}
              ></div>
            </div>
            <span id="animationAction"></span>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              onGridReady={onGridReady}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Animation](https://www.ag-grid.com/archive/36.2.0/examples/row-animation/animation/reactFunctionalTs/)

## Animation Sequence Details

You do not need to know how the animations work, however, if you are creating a theme or otherwise want to adjust the animations, it will be useful for you to understand the sequence of rules which are as follows:

- **New Rows:** Rows that are new to the grid are placed in the new position and faded in.
- **Old Rows:** Rows that are no longer in the grid are left in the same position and faded out.
- **Moved Rows:** Rows that are in a new position get their position transitioned to the new position.
- **Resized Height Rows:** Rows that get their height change will have the height transitioned to the new height.

In addition to the transition animations, old rows are placed behind new rows such that moving rows are on top of old rows when moved (hence old rows are not fading out on top of new rows, but behind new rows).
